/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.capi.test;

import javax.ejb.EJB;
import javax.ejb.Stateless;

/**
 *
 * @author ctabin
 */
@Stateless
public class FacadeBean implements FacadeLocal
{

    @EJB private ExceptionLauncherNELocal _noInterceptor;
    @EJB private ExceptionLauncherWELocal _withInterceptor;
    @EJB private PostProcessorLocal _postProcessor;

    public String test(String input, boolean encapsulate)
    {
        String result = "noProcess";

        try
        {
            //throw new RuntimeException("Simple exception");
            if (encapsulate) _withInterceptor.launch();
            else _noInterceptor.launch();
        }
        catch(Exception e)
        {
            System.out.println("####################################################");
            System.out.println("Exception catched : "+e);
            System.out.println("Bean references are now : postProcessor="+_postProcessor+
                               ", noInterceptor="+_noInterceptor+", withInterceptor="+_withInterceptor);
            System.out.println("####################################################");

            //if the RuntimeException is not encapsulated, then this line will crash severly
            result = _postProcessor.process(input);

            System.out.println("####################################################");
            System.out.println("Final result is now : "+result);
            System.out.println("####################################################");
        }
        finally
        {
            System.out.println("####################################################");
            System.out.println("This message is just printed in the finally block");
            System.out.println("####################################################");
        }

        return result;
    }

}
