/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ch.capi.net;

import ch.capi.test.FacadeLocal;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;

/**
 * @author ctabin
 */
public class EncapsulationBean
{
    //---------//
    //Constants//
    //---------//

    //---------//
    //Variables//
    //---------//

    @EJB
    private FacadeLocal _remote;

    //-----------//
    //Constructor//
    //-----------//

    public EncapsulationBean()
    {
        _remote = lookupFacadeBean();
    }

    //--------------//
    //Public methods//
    //--------------//

    public String processRequest(HttpServletRequest req) throws ServletException, IOException
    {
        String encapsulation = req.getParameter("encapsulation");
        if (encapsulation == null) return null;

        boolean encapsulate = encapsulation.equalsIgnoreCase("true");
        return _remote.test("Sample input", encapsulate);
    }

    //-----------------//
    //Protected methods//
    //-----------------//

    //---------------//
    //Private methods//
    //---------------//

    private FacadeLocal lookupFacadeBean()
    {
        try
        {
            Context c = new InitialContext();
            return (FacadeLocal) c.lookup("java:comp/env/FacadeBean");
        } catch (NamingException ne)
        {
            Logger.getLogger(getClass().getName()).log(Level.SEVERE, "exception caught", ne);
            throw new RuntimeException(ne);
        }
    }
}
